leetcode 128 最长连续序列 (Longest Consecutive Sequence)

给定一个未排序的整数数组 nums ,找出数字连续的最长序列(不要求序列元素在原数组中连续)的长度。

进阶:你可以设计并实现时间复杂度为 O(n) 的解决方案吗?

Given an unsorted array of integers nums, return the length of the longest consecutive elements sequence.

Follow up: Could you implement the O(n) solution?

Example 1:
Input: nums = [100,4,200,1,3,2]
Output: 4
Explanation: The longest consecutive elements sequence is [1, 2, 3, 4]. Therefore its length is 4.

Example 2:
Input: nums = [0,3,7,2,5,8,4,6,0,1]
Output: 9

链接:https://leetcode-cn.com/problems/longest-consecutive-sequence

解决思路:

因为要满足O(n)的时间复杂度,就考虑能否使用哈希表查找来进行处理,因为在哈希表中查找元素是常数级的时间复杂度。

本题是求数组中的数字连续的最长序列,采用map的key来存储vector中的数字,map的value来存储该元素有没有被计算过,初始化的value都为false。然后,遍历数组中的元素,对每个元素ele都在map中循环查找其ele+1和ele-1,直到find的结果为空为止,每找到一次length就递增,并需要将找到元素在map中的value值标记为true,代表该元素已经被计算过了,下次遍历可以直接跳过该元素。最后,我们需要采用longest来记录一下每次求的length中的最长的结果。

代码如下:

class Solution {
public:
    int longestConsecutive(vector<int>& nums) 
    {
        unordered_map<int, bool> map;
        int longest;

        for(auto& ele : nums)
        {
            map[ele] = false;
        }

        for(auto& ele : nums)
        {
            if(map[ele])
            {
                continue;
            }

            int length = 1;

            for(int j = ele + 1; map.find(j) != map.end(); j++)
            {
                map[j] = true;
                length++;
            }
            for(int j = ele - 1; map.find(j) != map.end(); j--)
            {
                map[j] = true;
                length++;
            }
            longest = length > longest ? length : longest;
        }

        return longest;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值